//-----------------------------------------------------------------------------
//                                           Mn MA Osma Bars v1.1             |
//-----------------------------------------------------------------------------
#property copyright "Mn"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_width1  1
#property indicator_width2  1

extern int mMa1 = 3,
           mMa2 = 5,
           mMaType = 1,
           mAlertBar = 1;     // 0 = current bar, 1 = prev bar
extern bool mDrawLines  = true,
            mShowArrows = true;
           
double     mUp[], mDn[],
           mPipFact  = 1,
           mGap      = 5;

//-----------------------------------------------------------------------------
void init()
 {
  if(Digits == 3 || Digits == 5)
    mPipFact = 10;
  SetIndexBuffer(1, mUp);
  SetIndexBuffer(0, mDn);
  
  SetIndexEmptyValue(0, 0);
  SetIndexEmptyValue(1, 0);
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexArrow(0, 234);

  SetIndexStyle(1, DRAW_ARROW);
  SetIndexArrow(1, 233);  

  if(Period() > 1440)  mGap = 60;
  else if(Period() > 240)   mGap = 30;
  else if(Period() > 30)   mGap = 20;
  
  mGap *= Point * mPipFact;
   
  return(0);  
 }

//-----------------------------------------------------------------------------
void deinit()
 {
   for(int i = ObjectsTotal(); i >= 0; i--)
     if(StringSubstr(ObjectName(i), 0, 2) == "m.")
       ObjectDelete(ObjectName(i));

  return(0);  
 }

//-----------------------------------------------------------------------------
void start() 
{
  static bool mLong;
  static int mTime;
  
  int mCounted = IndicatorCounted();
  if(mCounted < 0) return (-1); 
  if(mCounted > 0) mCounted--;
  int mLimit = Bars - mCounted;
     
  for (int i = mLimit; i >= 0; i--) 
   { 
     double mVal1 = iMA(NULL, 0, mMa1, 0, mMaType, PRICE_CLOSE, i+mAlertBar);
     double mVal11 = iMA(NULL, 0, mMa1, 0, mMaType, PRICE_CLOSE, i+1+mAlertBar);
     double mVal2 = iMA(NULL, 0, mMa2, 0, mMaType, PRICE_CLOSE, i+mAlertBar);
     double mVal21 = iMA(NULL, 0, mMa2, 0, mMaType, PRICE_CLOSE, i+1+mAlertBar);
     double mOs = iOsMA(NULL, 0, 12, 26, 9, PRICE_CLOSE, i+mAlertBar);
  //   double mOs1 = iOsMA(NULL, 0, 12, 26, 9, PRICE_CLOSE, i+1+mAlertBar);
     
     if(mOs > 0)    // look for long
       {
         if(Time[i+1] > mTime && (!mLong && mVal1 > mVal2) || (mLong && mVal1 > mVal2 && mVal11 <= mVal21))
           {
             if(mShowArrows)
               mUp[i+mAlertBar] = High[i+mAlertBar] + mGap; 
             if(mDrawLines)
               DrawEntryLine(Time[i+mAlertBar], Aqua);
             if(i < 2)
               Alert(Symbol(), "  ", Period(), "m MA & Osma Up ", DoubleToStr(Close[0], Digits));
             mLong = true;  
             mTime = Time[i+1];
           }
       }
       
     else if(mOs < 0)    // look for short
       {
         if(Time[i+1] > mTime && (mLong && mVal1 < mVal2) || (!mLong && mVal1 < mVal2 && mVal11 >= mVal21))
           {
             if(mShowArrows)
               mDn[i+mAlertBar] = Low[i+mAlertBar] - mGap; 
             if(mDrawLines)
               DrawEntryLine(Time[i+mAlertBar], Pink);
             if(i < 2)
               Alert(Symbol(), "  ", Period(), "m MA & Osma Down ", DoubleToStr(Close[0], Digits));
             mLong = false;  
             mTime = Time[i+1];
           }
       }
   }  // for i 

  return(0);  
}

//-----------------------------------------------------------------------------
void DrawEntryLine(int mT, color mCol)
 {
   ObjectCreate("m.Alert"+mT,OBJ_VLINE,0,mT,0,mT,0);
   ObjectSet("m.Alert"+mT,OBJPROP_COLOR, mCol);
   ObjectSet("m.Alert"+mT,OBJPROP_BACK, true);
   ObjectSet("m.Alert"+mT,OBJPROP_WIDTH, 2);
   
   return(0);
 }
 
 //-----------------------------------------------------------------------------

